{
    description = "@project_description@";

    inputs = {
        nixpkgs.url = "github:NixOS/nixpkgs/nixpkgs-unstable";
        rust-overlay ={
            url = "github:oxalica/rust-overlay";
            inputs.nixpkgs.follows = "nixpkgs";
        };
    };

    outputs = { nixpkgs, rust-overlay, ... }:
    let
        system = "x86_64-linux";

        overlays = [ (import rust-overlay) ];
        pkgs = import nixpkgs {
            inherit system overlays;
        };

        rust = pkgs.rust-bin;

        rustToolchain = rust.fromRustupToolchainFile ./rust-toolchain.toml;
        rustNightlyToolchain = rust.selectLatestNightlyWith(tc: tc.minimal.override {
            extensions = [ "rustfmt" ];
            targets = [ "x86_64-unknown-linux-gnu" ];
        }) ;

        buildTools = [
            rustToolchain
            rustNightlyToolchain
        ];

        devShell = pkgs.mkShell {
            name = "@project_name@";
            buildInputs = buildTools;
            packages = with pkgs; [
                rust-analyzer
            ];
        };
    in {
        devShells.${system}.default = devShell;
    };
}
